package meerkat.pollingstation.controller.callbacks;

import com.google.common.util.concurrent.FutureCallback;
import meerkat.protobuf.PollingStation;

/**
 * Created by Laura on 3/20/2017.
 */
public class ScanDataCallback extends ScanCallback implements FutureCallback<PollingStation.ScannedData> {

    private final PollingStation.ScannedData expectedData;
    private final PollingStation.ErrorMsg errorMsg;
    private boolean dataIsAsExpected;
    private Throwable thrown;

    public ScanDataCallback(PollingStation.ScannedData expectedData) {
        this.expectedData = expectedData;
        this.errorMsg = null;
    }

    public ScanDataCallback(PollingStation.ErrorMsg errorMsg) {
        this.expectedData = null;
        this.errorMsg = errorMsg;
    }

    @Override
    public void onSuccess(PollingStation.ScannedData result) {
        dataIsAsExpected = result.getChannel().equals(expectedData.getChannel());
    }

    @Override
    public void onFailure(Throwable t) {
        dataIsAsExpected = false;
        thrown = t;
    }

    public void doNothing() {
        System.out.println("do nothing hit");
    }
}
